import es, gamethread, playerlib, os.path, popuplib 
from configobj import ConfigObj 

info = es.AddonInfo()
info.name     = "Addon Vote"
info.version  = "1.0"
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=28863"
info.basename = "addon_vote"
info.author   = "UGSlayer + BonBon"

FILEPATH = es.getAddonPath('addonvote') + '/' 

### Classes ### 

class VotePlayer(object): 
        def __init__(self, userid): 
                self.userid = userid 
                self.pd = {} 

        def vote_select(self, choice, popup): 
                run = True 
                if not popup in self.pd: 
                        self.pd[popup] = choice 
                        run = False 

                if choice == self.pd[popup] and run: 
                        es.tell(self.userid, '#multi', '#lightgreen[Addon Vote]: #defaultYou have already selected #lightgreen%s#default for #lightgreen%s#default!'%(choice, popup)) 
                        return 

                self.pd[popup] = choice 
                VM.addVote(popup, 'yes' if choice == VM.md[popup]['yes_option'] else 'no', run) 

class VoteManager(object): 
        def __init__(self): 
                self.cd = {} 
                self.ad = {} 
                self.md = {} 

                self.MainMenu = None 
                self.playercount = len(filter(lambda x: not es.getplayersteamid(x) == 'BOT', es.getUseridList())) 

        def getPlayer(self, userid): 
                userid = int(userid) 
                if not userid in self.cd: 
                        self.cd[userid] = VotePlayer(userid) 
                return self.cd[userid] 

        def removePlayer(self, userid): 
                if int(userid) in self.cd: 
                        pd = self.cd[int(userid)].pd 
                        for popup in pd: 
                                choice = 'yes' if pd[popup] == self.md[popup]['yes_command'] else 'no' 
                                self.ad[choice] -= 1 
                                self.check_won(popup, choice) 
                        del self.cd[int(userid)] 

        def createMenus(self): 
                self.MainMenu = popuplib.easymenu('Vote Config', '_popup_choice', self.mainMenuSelect) 
                for option in self.md: 
                        self.MainMenu.addoption(option, option + ' [0/%s]'%(self.playercount)) 

                        config_menu = popuplib.easymenu(option, '_popup_choice', lambda u, c, p: self.getPlayer(u).vote_select(c, p)) 
                        config_menu.addoption(self.md[option]['yes_option'], self.md[option]['yes_option']) 
                        config_menu.addoption(self.md[option]['no_option'], self.md[option]['no_option']) 

                        self.ad[option] = {'yes': 0, 'no': 0} 

        def mainMenuSelect(self, userid, choice, popupid): 
                if popuplib.isqueued(choice, userid): 
                        popuplib.close(choice, userid) 
                popuplib.send(choice, userid) 

        def addVote(self, popup, choice, chosen): 
                switch = 'yes' if choice == 'no' else 'no' 
                if chosen: 
                        self.ad[popup][switch] -= 1 

                self.ad[popup][choice] += 1 
                self.check_won(popup, choice) 
                self.MainMenu.setoption(popup, text=popup + ' [%s/%s]'%(self.ad[popup]['yes'], self.playercount)) 

        def check_won(self, popup, choice): 
                switch = 'yes' if choice == 'no' else 'no' 
                if self.ad[popup][choice] - self.ad[popup][switch] == 1: 
                        es.msg('#multi', '#lightgreen[Addon Vote]: %s#default has been toggled to #lightgreen%s#default !'%(popup, 'on' if choice == 'yes' else 'off')) 
                        es.server.queuecmd(self.md[popup]['%s_command'%choice]) 

VM = VoteManager() 

### Loads ### 

def load(): 
        if not os.path.isfile(FILEPATH + 'addonvote.ini'): 
                es.dbgmsg(0, 'No addonvote.ini present under ./cstrike/addons/eventscripts/addonvote !') 
                return 

        VM.md = dict(ConfigObj(FILEPATH + 'addonvote.ini')) 
        VM.createMenus() 

        if not es.exists('saycommand', '!vote'): 
                es.regsaycmd('!vote', 'addonvote/vote') 
                es.msg('#multi', '#lightgreen[Addon Vote]: #defaultPlayers can now type #lightgreen!vote#default to vote for server options!') 

        for userid in es.getUseridList(): 
                if not es.getplayersteamid(userid) == 'BOT': 
                        VM.getPlayer(userid) 

def unload(): 
        if es.exists('saycommand', '!vote'): 
                es.unregsaycmd('!vote') 

### Events ### 

def player_activate(ev): 
        if not ev['es_steamid'] == 'BOT': 
                VM.playercount += 1 
                VM.getPlayer(ev['userid']) 

def player_disconnect(ev): 
        if not ev['es_steamid'] == 'BOT': 
                VM.playercount -= 1 
                VM.removePlayer(ev['userid']) 

### Commands ### 

def vote(): 
        userid = es.getcmduserid() 
        if popuplib.isqueued('Vote Config', userid): 
                popuplib.close('Vote Config', userid) 
        popuplib.send('Vote Config', userid)